#ifndef NDS_TESTING_HH
#define NDS_TESTING_HH

// Function and classes defined within this file are
//   intended to help with testing of the NDS software.

#include <cstdlib>
#include <memory>
#include <string>
#include <iostream>

template < typename T >
using pointer = std::unique_ptr< T >;

#define NDS_ASSERT( bool_expression )                                          \
    nds_assert( ( bool_expression ), __FILE__, __LINE__ )

static inline void
nds_assert( bool expression, std::string fname, int lineno )
{
    if ( !expression )
    {
        std::cerr << "Assertion at " << fname << ":" << lineno << " was false."
                  << std::endl;
        std::abort( );
    }
}

#endif /* NDS_TESTING_HH */
